#include <bits/stdc++.h>
using namespace std;
const int N=5e5+5;
int n,q,x,y,k,L[N],R[N],dfn[N],id[N],siz[N],son[N],idx=0,dis[N],mxp;
int fa[N],sum[N],mx[N],mn[N],tot=0,now=0;
int dot[N],top=0;
bool vis[N],fff[N];
vector<int>g[N];
vector<pair<int,int> >dep[N];
struct dsu{
	int u,v,fat,siz,mn,mx;
}del[N];
void dfs1(int u,int fa){
	dis[u]=dis[fa]+1;
	mxp=max(mxp,dis[u]);
	L[u]=dfn[u]=++idx;
	id[idx]=u;
	siz[u]=1;
	for(int i=0;i<g[u].size();i++){
		int v=g[u][i];
		if(v==fa)continue;
		dfs1(v,u);
		siz[u]+=siz[v];
		if(siz[v]>siz[son[u]])son[u]=v;
	}
	R[u]=idx;
}
int find(int x){
	if(fa[x]==x)return x;
	return find(fa[x]);
}
void merge(int u,int v){
	u=find(u),v=find(v);
	if(u==v)return;
	if(sum[u]<sum[v])swap(u,v);
	del[++tot]={u,v,fa[v],sum[u],mn[u],mx[u]},now++;
	fa[v]=u,sum[u]+=sum[v];
	mn[u]=min(mn[u],mn[v]),mx[u]=max(mx[u],mx[v]);
	if(!fff[u])dot[++top]=u;
	fff[v]=0,fff[u]=1;
}
void add(int u){
	vis[u]=1;
	if(vis[u-1])merge(u,u-1);
	if(vis[u+1])merge(u,u+1);
	if(!vis[u-1]&&!vis[u+1]){
		if(!fff[u]){
			fff[u]=1;
			dot[++top]=u;
		}
	}
}
void dfs2(int u,int f,bool flag){
//	cout <<u<<",";
	for(int i=0;i<g[u].size();i++){
		int v=g[u][i];
		if(v==f||v==son[u])continue;
		dfs2(v,u,0);
	}
	if(son[u])dfs2(son[u],u,1);
	top=0,now=0;
	add(u);
	for(int i=0;i<g[u].size();i++){
		int v=g[u][i];
		if(v==f||v==son[u])continue;
		for(int j=L[v];j<=R[v];j++){
			add(id[j]);
		}
	}
	for(int i=1;i<=top;i++){
		int v=dot[i];
		if(fff[v])dep[dis[u]].push_back(make_pair(mn[v],mx[v]));
		fff[v]=0;
	}
	if(!flag){
		while(now--){
			int i=tot;
			int x=del[i].u,y=del[i].v;
			fa[y]=del[i].fat,sum[x]=del[i].siz,mn[x]=del[i].mn,mx[x]=del[i].mx;
			tot--;
		}
		for(int i=L[u];i<=R[u];i++){
			int v=id[i];
			vis[v]=0;
		}
	}
}
struct seg{
	int ls,rs,num;
}tree[N*40];
int root[N],cnt=0;
int ask(int rt,int pre,int l,int r,int k){
	if(l==r)return l;
	int mid=l+r>>1;
	int now=tree[tree[rt].rs].num-tree[tree[pre].rs].num;
	if(k<=now)return ask(tree[rt].rs,tree[pre].rs,mid+1,r,k);
	else return ask(tree[rt].ls,tree[pre].ls,l,mid,k-now);
}
void update(int &rt,int pre,int l,int r,int x){
	rt=++cnt;
	tree[rt]=tree[pre];
	tree[rt].num++;
	if(l==r)return;
	int mid=l+r>>1;
	if(x<=mid)update(tree[rt].ls,tree[pre].rs,l,mid,x);
	else update(tree[rt].rs,tree[pre].rs,mid+1,r,x);
}
int pp[N],ppp=0;
int main(){
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	scanf("%d",&n);
	for(int i=1;i<=n;i++)fa[i]=mx[i]=mn[i]=i,sum[i]=1;
	for(int i=1;i<n;i++){
		scanf("%d%d",&x,&y);
		g[x].push_back(y);
		g[y].push_back(x);
	}
	dfs1(1,0);
	dfs2(1,0,1);
	bool flag=0;
	for(int i=1;i<=n;i++){
		if(g[i].size()>2)flag=1;
	}
	if(!flag){
		root[0]=++cnt;
		for(int i=1;i<=n;i++)update(root[i],root[i-1],1,n,dis[i]);
		scanf("%d",&q);
		while(q--){
			scanf("%d%d%d",&x,&y,&k);
			for(int i=x;i<=y;i++)pp[++ppp]=dis[i];
			sort(pp+1,pp+1+ppp);
			printf("%d\n",pp[ppp-k+1]);
		}
		return 0;
	}
	scanf("%d",&q);
	while(q--){
		scanf("%d%d%d",&x,&y,&k);
		int ans=0;
		for(int i=1;i<=mxp;i++){
			for(int j=0;j<dep[i].size();j++){
				int l=dep[i][j].first,r=dep[i][j].second;
				if(min(r,y)-max(x,l)+1>=k)ans=max(ans,i);
			}
		}
		printf("%d\n",ans);
	}
	return 0;
}
//-O2 -std=c++14 -static
